
//Declaracin del proyecto #1
unsigned int conversion(unsigned int numero);
unsigned int digMSB, digito1, digLSB, pot, displayLSB, displayMSB,i;
void lectura_analogica();
//Declaracin del proyecto #2
unsigned int conversion(unsigned int numero);
unsigned int apuesta,apuestafinal,cuenta,topo,tmpTopo,tmTOPO,jugadas,tecla;
unsigned int dinero(unsigned int cuenta);
void digitos(unsigned int num);
void inicio_juego_topo();

void main() {

     ANSELH = 0x00;    //Declaracin de Puertos como analogico el RA1
     ANSEL  = 0x01;
     TRISA  = 0xFF;    //Puerto A configurado como entrada
     TRISC  = 0x00;    //Los otros puertos configurados como salida
     TRISD  = 0x00;
     TRISB  = 0x00;
     PORTB  = 0x00;    //Setear el puerto B
     C1ON_bit = 0;               // Deshabilita comparadores
     C2ON_bit = 0;
     ADC_Init();         //Inicializa el ADC del pic
     apuestafinal=0;     //Seteo de las variables1
     apuesta=0;
     cuenta=0;
     jugadas=0;
     PORTD= 0x77;        //Mostrar las inciales del nombre en los displays
     PORTC= 0x38;
     delay_ms(200);
     while(1){            //Eleccin del juego a escojer
        if(Button(&PORTA,1,18,1))
            lectura_analogica();
        else if(Button(&PORTA,2,18,1))
            inicio_juego_topo();
            
     }
}
//Funcin que convierte los valores decimales a hexadecimal necesarios para mostrarse en lso displays
unsigned int conversion(unsigned int numero) {
         switch (numero) {
                case 0 : return 0x3F;
                case 1 : return 0x06;
                case 2 : return 0x5B;
                case 3 : return 0x4F;
                case 4 : return 0x66;
                case 5 : return 0x6D;
                case 6 : return 0x7D;
                case 7 : return 0x07;
                case 8 : return 0x7F;
                case 9 : return 0x6F;
         }
}
//Funcin que sirve para leer el valor analogico y obtener la conversion para ser mostrada en los displays
void lectura_analogica()
{
      while(1){
          pot = ADC_read(0);    //Lee la entrada analogica por medio del ADC
          digito1=(pot*5*19.8)/1023;   //Conversin de los valores del ADC a valores decimales del 0 a 99
          PORTB=digito1;               //Mostrar el valor de la conversion en el puerto B
          digLSB= digito1%10;          //Obtiene el valor de las unidades del numero decimal
          displayLSB= conversion(digLSB); //Obtener el valor Hexadecimal para mostrar en los displays
          PORTC= displayLSB;             //Mostrar en el puerto C unidades
          digMSB=(digito1/10)%10;        //Obtiene el valor de las decenas del numero decimal
          displayMSB=conversion(digMSB);  //Obtener el valor Hexadecimal para mostrar en los displays
          PORTD= displayMSB;             //Mostrar en el puerto D decenas

     }
}
//Funcin encargada de generar el juego de topo
void inicio_juego_topo()
{
     tecla=0;                //Setear la variable
     PORTC= 0x73;            //Mostrar mensaje "AP" de apuesta
     PORTD= 0x77;
     apuestafinal=dinero(cuenta);     //Obtener la suma de la puesta
     digitos(apuestafinal);           //Mostrar dicha apuesta en los displays
     delay_ms(100);
     PORTC=0x5C;               //Mostrar el mensaje "To" deciendo topo
     PORTD=0x78;
     delay_ms(200);
     do{
          topo=rand()%4+1;            //Generar numeros aleatorios desde el 1 a 4 para simulacin de los topos
          digitos(topo);              //Mostrar el numero del topo en los displays
          delay_ms(500);
          if(Button(&PORTA,1,66,1)&&topo==1){   //Verifica si ha sido presionado la tecla del respectivo topo y compara dicho topo
               apuestafinal++;                  //Si es as le incrementa su apuesta en "1"
          }
          else if(Button(&PORTA,2,66,1)&&topo==2){
               apuestafinal++;
          }
          else if(Button(&PORTA,3,66,1)&&topo==3){
               apuestafinal++;
          }
          else if(Button(&PORTA,4,66,1)&&topo==4){
               apuestafinal++;
          }
          else{
             apuestafinal--;
          }
          jugadas++;                      //Maximo de jugadas
     }while(apuestafinal!=0&&jugadas<10);  //Condicion para la terminacin del juego ya sea por el maximo de jugadas o apuesta cero
     PORTC=0x5C;          //Mostrar mensaje de "Go" de game over en los displays
     PORTD=0x7D;
     delay_ms(200);
     digitos(apuestafinal);   //Mostrar la apuesta final en los displays
     delay_ms(200);
}
//Funcin encargada de obtener el dinero de la apuesta
unsigned int dinero(unsigned int cuenta)
{
    apuesta=0;      //Seteo de las variables
    cuenta=0;
    i=0;
    do{
          if(Button(&PORTA,1,66,1)&&i!=1){  //Verifica si ha sido presionado la tecla de 1 dlar
               apuesta=1;                   //si es as la apuesta es "1" y acumula ese valor
               cuenta=cuenta+apuesta;
               i=1;                         //sirve para que no se repita la apuesta
          }
          else if(Button(&PORTA,2,66,1)&&i!=2){
               apuesta=2;
               cuenta=cuenta+apuesta;
               i=2;
          }
          else if(Button(&PORTA,3,66,1)&&i!=3){
               apuesta=3;
               cuenta=cuenta+apuesta;
               i=3;
          }

     }while(!RA4_bit);
     return cuenta;
}
//Muestra los digitos para el juego de los topos
void digitos(unsigned int num)
{
          PORTB=num;
          digLSB= num%10;
          displayLSB= conversion(digLSB);
          PORTC= displayLSB;
          digMSB=(num/10)%10;
          displayMSB=conversion(digMSB);
          PORTD= displayMSB;
}